#!/usr/bin/perl
#
# Exact.cgi by Kazz Asher
#
# Original code Dave Nelson
# Kazz Asher Fixed a socket problem and wrote html
#
# Gerold Bigorajski adapted it for European output
#   http://www.gb-direkt.de
#
# Need a script? Write me at kazz@asher.net or visit
#   http://spectravision.net


$script_url = "http://www.gb-direkt.de/cgi-bin/atomuhr.cgi"; # this script's URL

$show_am_pm = 0; # Set to one if you want to have 12 hour AM/PM clock.

# HTML-Header so that comments go to the browser and we don't get a timeout 
# while establishing socket.

print "Content-type:text/html\n\n";

# use Socket module on port 80

use Socket;
$port = 80;

# German months

@months=("","Januar","Februar","Mrz","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember");

# this first section establishes the socket and connects to Boulder, CO

$sockaddr = 'S n a4 x8'; 

chop($hostname = `hostname`);
# print "\nUsing $hostname as host...\n\n";

($name, $aliases, $proto) = getprotobyname('tcp');
($name, $aliases, $type, $len, $thisaddr) = gethostbyname($hostname);

$thathost = "132.163.135.130";
# print "Connecting to: $thathost"."...\n\n";

($name, $aliases, $type, $len, $thataddr) = gethostbyname($thathost);
$port = 14;
$thisport = pack($sockaddr, &AF_INET, 0, $thisaddr);
$thatport = pack($sockaddr, &AF_INET, $port, $thataddr);

socket(S, &PF_INET, &SOCK_STREAM, $proto) || die "Kann Socket nicht erstellen\n";
bind(S,$thisport) || die "Kann keine Anbindung an Socket erstellen\n";
connect(S,$thatport) || die "Kann keine Verbindung fr Socket erstellen\n";

# Computing 

@output = <S>;
@fields = split(/ /,$output[1]);

$date_digital = $fields[1];
$time_zulu = $fields[2];
$status_digital = $fields[5];

&status_parse;
&date_parse;
&am_pm;
&time_parse;

# HTML Output

print qq~
<html>
<head>
<META HTTP-EQUIV="Refresh" CONTENT="5; URL=$script_url">
<title>Die exakte Uhrzeit ist $time_est $am_pm</title>
</head>
<body background="http://www.gb-direkt.de/_themes/sumipntg/sumtextb.jpg" bgcolor="#FFFFFF" text="#808080" link="#3333CC" vlink="#666699" alink="#990099">
<table width="100%">
	<tr>
		<td valign="top"><font face="verdana, arial, helvetica"><h2><font color="#003366">Atomuhr</font></h2></td>
		<td valign="top"><font face="verdana, arial, helvetica"><p align="right"><a target="_self" href="javascript:history.back()">Zurck</a></font></td>
	</tr>
</table>

<table width="100%" height="100%" border="0">
	<tr>
		<td align="center">
		<font face="verdana, arial, helvetica" size="3">Gem der ATOMUHR 
		<br>in Boulder, Colorado, 
		<br>ist die EXAKTE Zeit
		<h3><font color="#003366">$time_est $am_pm MEZ am $date_word</font></h3>
		<p>\&nbsp\;</p>
	</tr>
</table>
</body>
</html>
~;

sub status_parse
{
	if ($status_digital =~ 0)
	{
		$status_word = "\!"; # i.e. "the clock is functioning normally.";
	}
	else
	{
		$status_word = "Die Uhr funktioniert leider z.Z. nicht."; # i.e. "the clock is malfunctioning in some way.";
	}
}

sub date_parse
{
	@date_fields = split(/-/,$date_digital);
	$month="$months[$date_fields[1]]";
	@midnight = split(/:/,$time_zulu);
	if ($midnight[0] >= 23)
	{
		$date_fields[2] = $date_fields[2] - 1;
	}
	$date_word ="$date_fields[2]\. $month  19"."$date_fields[0]"; 
}

sub am_pm
{
	local($time);
	@time_field = split(/:/,$time_zulu);
	$time = $time_field[0] + 1;
	if ($time > 24)
	{
		$time = $time - 24;
	}
	if($show_am_pm)
	{
		$am_pm = "AM";
		if ($time >= 12)
		{
			$am_pm = "PM";
		}
	}
	else
	{
		$am_pm = "";
	}
}

sub time_parse
{
	$time_field[0] = $time_field[0] + 1;
	if ($time_field[0] <= 0)
	{
		$time_field[0] = $time_field[0] + 12;
	}

	if($show_am_pm)
	{
		if ($time_field[0] > 12)
		{
			$time_field[0] = $time_field[0] - 12;
		}
	}

	$time_est = join(":",@time_field);
}

